using SpellBoundAR.AssetManagement;
using SpellBoundAR.ResourceUtilities;
using UnityEngine;

namespace SpellBoundAR.ARImageTracking
{
    [CreateAssetMenu(menuName = "Scriptable Objects/AR/Image Tracking/Image Target")]
    public class ImageTargetData : IdentifiableScriptableObject
    {
        [Header("Settings")]
        [SerializeField] private bool contentEnabled = true;
        [SerializeField] private ResourceGameObject contentResource;
        [SerializeField] private Vector3 positionOffset;
        [SerializeField] private Quaternion rotationOffset;
        
        [Header("Image Target References")]
        [SerializeField] private Texture referenceImage;
        [SerializeField] private Sprite referenceSprite;

        public virtual bool ContentEnabled
        {
            get => contentEnabled;
            set => contentEnabled = value;
        }
        
        public Texture ReferenceImage => referenceImage;
        public Sprite ReferenceSprite => referenceSprite;
        public GameObject Content => contentResource ? contentResource.Asset : null;
        public Vector3 PositionOffset => positionOffset;
        public Quaternion RotationOffset => rotationOffset;

        public virtual void OnTracked() { }
    }
}
